//
//  FinalizeRecordingViewController.m
//  Blurbly
//
//  Created by Matthew Loseke on 10/26/13.
//  Copyright (c) 2013 Matthew Loseke. All rights reserved.
//

#import "FinalizeRecordingViewController.h"

@interface FinalizeRecordingViewController ()

@end

@implementation FinalizeRecordingViewController

@synthesize recordedAudioURL, recordedAudioFileName, audioFile, audioClipTitle;

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    if([[NSUserDefaults standardUserDefaults] boolForKey:@"popDisplayed2"] == FALSE)
    {
        [[NSUserDefaults standardUserDefaults] setBool:TRUE forKey:@"popDisplayed2"];
        [[NSUserDefaults standardUserDefaults] synchronize];
        
        
        RNBlurModalView *modal = [[RNBlurModalView alloc] initWithViewController:self title:@"Info" message:@"Give your audio a fitting title then press Post to finalize."];
        [modal show];
    }
    
    NSData *audioData = [[NSData alloc] initWithContentsOfURL:recordedAudioURL];
    audioFile = [PFFile fileWithName:recordedAudioFileName data:audioData];

}

- (IBAction)gotoAddRecording:(id)sender
{
    [self.navigationController popViewControllerAnimated:YES];
}
- (IBAction)save:(id)sender {
    [audioClipTitle resignFirstResponder];
    MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:self.view animated:YES];
    hud.labelText = @"Saving";
    [PFUser currentUser] ? [self saveWithCurrentUser] : [self saveWithDefaultUser];
}

- (void)saveWithDefaultUser
{
    [PFUser logInWithUsernameInBackground:@"Dfault" password:@"p@ssw0rd" block:
     ^(PFUser *user, NSError *error) {
         if (user) {
             [self saveWithCurrentUser];
         } else {
             // The login failed. Check error to see why.
         }
     }];
}

- (void)saveWithCurrentUser
{
    [audioFile saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
        PFObject *audioClip = [PFObject objectWithClassName:@"AudioClip"];
        audioClip[@"title"] = audioClipTitle.text;
        audioClip[@"audio"] = audioFile;
        
        [audioClip setObject:[PFUser currentUser] forKey:@"user"];
        
        [audioClip saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
            // save was successfull
            [MBProgressHUD hideHUDForView:self.view animated:YES];
            [self dismissViewControllerAnimated:YES completion:^{
//                [self dismissViewControllerAnimated:YES completion:^{
//                    // get back to feed view controller
//                }];
            }];
        }];
    }];
}

@end
