//
//  SettingsViewController.m
//  Blurbly
//
//  Created by Matthew Loseke on 10/18/13.
//  Copyright (c) 2013 Matthew Loseke. All rights reserved.
//

#import "SettingsViewController.h"

@interface SettingsViewController ()

@end

@implementation SettingsViewController

@synthesize menuItems, loginText;

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // Uncomment the following line to preserve selection between presentations.
    self.clearsSelectionOnViewWillAppear = YES;
    
    self.tableView.backgroundColor = [UIColor clearColor];
    self.tableView.opaque = NO;
    [self.tableView setBackgroundColor:[UIColor colorWithRed:99.0f/255.0f green:100.0f/255.0f blue:102.0f/255.0f alpha:1]];
    
    menuItems = @[@"login"];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated
{
    if ([PFUser currentUser]) {
        UILabel *label = (UILabel *)[[(UITableViewCell *)[self.tableView dequeueReusableCellWithIdentifier:@"login"] contentView] viewWithTag:1];
        label.text = @"Logout";
        [self.tableView reloadData];
    }
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [self.menuItems count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *CellIdentifier = [self.menuItems objectAtIndex:indexPath.row];
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
   
    if ([CellIdentifier isEqualToString:@"login"]) {
        if ([PFUser currentUser]) {
            UILabel *label = (UILabel *)[cell.contentView viewWithTag:1];
            label.text = @"Logout";
        }
    } else {
        UILabel *label = (UILabel *)[cell.contentView viewWithTag:1];
        label.text = @"Login";
    }
    
   cell.backgroundColor = [UIColor clearColor];
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *CellIdentifier = [self.menuItems objectAtIndex:indexPath.row];
    if ([CellIdentifier isEqualToString:@"login"]) {
        UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
        [self didSelectLoginCell: cell];
    }
}

- (void)prepareForSegue: (UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue isKindOfClass: [SWRevealViewControllerSegue class]]) {
        SWRevealViewControllerSegue *swSegue = (SWRevealViewControllerSegue *) segue;
        
        // Set the title of navigation bar by using the menu items
        NSIndexPath *indexPath = [self.tableView indexPathForSelectedRow];

        //maybe profile view controller
        UIViewController *destViewController = segue.destinationViewController;
        destViewController.title = [[menuItems objectAtIndex:indexPath.row] capitalizedString];
        
        UIBarButtonItem *button = [[UIBarButtonItem alloc] initWithTitle:@"=" style:UIBarButtonItemStylePlain target:self.revealViewController action:@selector(revealToggle:)];
        button.tintColor = [UIColor colorWithRed:252.0f/255.0f green:63.0f/255.0f blue:67.0f/255.0f alpha:1.0f];
        
        //todo - make the button text color red
        [destViewController.navigationItem setLeftBarButtonItem:button];
        
        swSegue.performBlock = ^(SWRevealViewControllerSegue *rvc_segue, UIViewController *svc, UIViewController *dvc) {
            UINavigationController *navController = (UINavigationController *)self.revealViewController.frontViewController;
            [navController setViewControllers: @[dvc] animated: NO];
            [self.revealViewController setFrontViewPosition: FrontViewPositionLeft animated: YES];
        };
    }
}

- (void)didSelectLoginCell: (UITableViewCell *)cell
{
    if (![PFUser currentUser]) { // No user logged in
        // Create the log in view controller
        PFLogInViewController *logInViewController = [[PFLogInViewController alloc] init];
        [logInViewController setDelegate:self]; // Set ourselves as the delegate
        
        // Create the sign up view controller
        PFSignUpViewController *signUpViewController = [[PFSignUpViewController alloc] init];
        [signUpViewController setDelegate:self]; // Set ourselves as the delegate
        
        // Assign our sign up controller to be displayed from the login controller
        [logInViewController setSignUpController:signUpViewController];
        
        // Present the log in view controller
        [self presentViewController:logInViewController animated:YES completion:NULL];
    } else {
        [PFUser logOut];
        UILabel *label = (UILabel *)[cell viewWithTag:1];
        label.text = @"Login";
    }
}

// Sent to the delegate when a PFUser is logged in.
- (void)logInViewController:(PFLogInViewController *)logInController didLogInUser:(PFUser *)user {
    [self dismissViewControllerAnimated:YES completion:^{
        [self.revealViewController revealToggle:self];
    }];
}

@end

